
/* ajaxq.js is a client based component of the ajaxQ  software written in javascript. It is used to  access server based MySQL databases by communicating with the server based component ajaxq.php
Copyright (C) 2006 Britt Juliff
juliff@ajaxq.com

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

/* MySQL is a registered trademark of MySQL AB in the United States, the European Union and other countries. */

// ajaxQ is the javascript object that must be instatiated to use ajaxQ
function ajaxQ(){
//this variable contains the number of rows affected by the last insert, delete or update. It is set programmatically by ajaxQ and doesn't need to be set by the user.
	this.nbrAffectedRows = 0
//this variable contains the id of the last autoincrement id created on an insert. It is set programmatically by ajaxQ and doesn't need to be set by the user.
	this.lastId=0
//this variable contains the error message from the last sql statement that caused an error. It is set programmatically by ajaxQ and doesn't need to be set by the user.
	this.errorMessage = null
//this variable contains the error number from the last sql statement that caused an error. It is set programmatically by ajaxQ and doesn't need to be set by the user.
	this.errorNbr = 0
//this function sets the php file used to connect to the database. This programmatically set to 'ajaxqconfig.php' by default.
	this.setConfigFile =  function (cf){
		this.ConfigFile=cf
	}
//this function is passed a 'true' to make an asynchronous ajaxQ call or 'false' for synchronous. Calling setWhenCompleteCallback programmatically sets up ajaxQ to make an asynchronous call.
	this.setAsync =  function (async){
		this.Async=async
	}		
//this function sets the name of the php file to process the SQL passed to the server. This programmatically set to 'ajaxq.php' default and doesn't need to be called by the user.
	this.setUrl =  function (url){
		this.Url=url
	}
//this function sets up a callback function to be executed when the AJAX request is  loading. Calling this is optional.
	this.setWhenLoadingCallback =  function (callback){
		this.WhenLoadingCallback=callback
	}
//this function sets up a callback function to be executed when the AJAX request is being loaded. Calling this is optional.
	this.setWhenLoadedCallback =  function (callback){
		this.WhenLoadedCallback=callback
	}	
//this function sets up a callback function to be executed when the AJAX request is interactive. Calling this is optional.
	this.setWhenInteractiveCallback =  function (callback){
		this.WhenInteractiveCallback=callback	
	}
//this function sets up a callback function to be executed when the AJAX request is complete. Calling this is required to process an asychronous query.
	this.setWhenCompleteCallback =  function (callback){
		this.Async=true
		this.WhenCompleteCallback=callback
	}
//this function sets up a callback function to be executed when the AJAX request aborts. Calling this is optional.
	this.setWhenAbortCallback =  function (callback){
		this.WhenAbortCallback=callback
	}	
//this function sets up a callback function to be executed when the AJAX request generates an error. Calling this is optional.
	this.setWhenErrorCallback =  function (callback){
		this.WhenErrorCallback=callback
	}
//this is the main function to be clled by the user to execute one or more SQL statements. It can be passed an individual SQL string or an array of SQL strings.	
	this.sqlQuery = function(sql){
		this.Sql = null
		this.Sql = new Array()	

		if(typeof sql == "string"){
			this.Sql[0]=sql
		}else{
			this.Sql = sql
		}
		this.GetXmlHttpObject()
		this.ajaxIt()
		if (!this.Async){
			this.whenComplete()
			if(typeof this.Sql == "string"){
				return this.resultId[0]
			}else{
				return this.resultId
			}
		}
	}
//this function gets around the problem of losing the "this" when setting onreadystatechange and is not called by the user.
	this.bindtothis = function(method, object) {
		return function() {
			method.apply(object);
		}
	}
//this function sets up the ajax object and is not called by the user.
	this.GetXmlHttpObject = function(){
		this.XMLHttp=null
		try{
			this.XMLHttp=new ActiveXObject("Msxml2.XMLHTTP")
		}
		catch(e){
			try{
				this.XMLHttp=new ActiveXObject("Microsoft.XMLHTTP")
			}
			catch(e){
			}
		}
		if (this.XMLHttp==null){
			this.XMLHttp=new XMLHttpRequest()
		}
		if (this.XMLHttp==null){
			alert ("Browser does not support HTTP Request")
		}
	}
//this function sends the ajax request to the server based php component  and is not called by the user.
	this.ajaxIt = function(){
		if (!this.ConfigFile){
			this.ConfigFile="ajaxqconfig.php"
		}
		if (!this.Async){
			this.Async=false
		}		
		if (!this.Url){
			this.Url="http://www.nyc-security.com/ajax/ajaxq.php"
		}
		if (!this.Sql){
			alert("Please call setSql() before calling sqlQuery()")
		}
		this.Url=this.Url+"?config_file="+this.ConfigFile
		for (i=0;i<this.Sql.length;i++){
			this.Url=this.Url+"&"+i+"="+escape(this.Sql[i])
		}
		this.Url=this.Url+"&sid="+Math.random()
		if (this.Async){
			this.XMLHttp.onreadystatechange=this.bindtothis(this.stateChanged,this)
		}
		if (this.XMLHttp==null){
			alert ("Browser does not support HTTP Request1")
		}
		this.XMLHttp.open("GET",this.Url,this.Async)
		this.XMLHttp.send(null)
	}
//this monitors the AJAX call to see if the state has changed and calls the appropriate callback function  and is not called by the user.
	this.stateChanged = function(){
		if (this.XMLHttp==null){
			alert ("Browser does not support HTTP Request2")
		}
		if(this.XMLHttp.readyState == 1 ){
			if (this.WhenLoadingCallback){
				this.WhenLoadingCallback();
			}
		}
		else if(this.XMLHttp.readyState == 2 ){
			if (this.WhenLoadedCallback){
				this.WhenLoadedCallback();
			}
		}
		else if(this.XMLHttp.readyState == 3 ){
			if (this.WhenInteractiveCallback){
				this.WhenInteractiveCallback();
			}
		}
		else if(this.XMLHttp.readyState == 4 ){
			if(this.XMLHttp.status == 0 ){
				this.WhenAbortCallback();
			}
			else if(this.XMLHttp.status == 200 && this.XMLHttp.statusText == "OK"){
				this.whenComplete();
				if(typeof this.Sql == "string"){
					this.WhenCompleteCallback(this.resultId[0])
				}else{
					this.WhenCompleteCallback(this.resultId)
				}
			}
			else{
				this.WhenErrorCallback(this.XMLHttp.status,this.XMLHttp.statusText,this.XMLHttp.responseText);
			}
		} 
	}
/* this function is called after a query is complete and processes all of the data that is returned from the server. It sets the variable result that contains an XML version of the result set returned from the server. It also set a variable called resultID that identifies the result set in ajaxQ fetch functions. It  is not called by the user. */
	this.whenComplete = function(){
		this.result = null
		this.resultId = null
		this.result = new Array()
		this.resultId = new Array ()
		this.xmlDoc=null
		this.parser=null
		if (window.ActiveXObject){
			this.xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
			this.xmlDoc.async=false;
			this.xmlDoc.loadXML(this.XMLHttp.responseText);
		}else{
			this.parser=new DOMParser();
			this.xmlDoc=this.parser.parseFromString(this.XMLHttp.responseText,"text/xml");
		}
		this.phpXML=this.xmlDoc.documentElement;
		this.row = null
		this.row = new Array()
		for (i=0;i<this.phpXML.childNodes.length;i++){
			if (this.phpXML.childNodes[i].nodeName == "true"){
				this.resultId[i]=true
				this.lastId=this.phpXML.childNodes[i].childNodes[0].childNodes[0].nodeValue
				this.nbrAffectedRows=this.phpXML.childNodes[i].childNodes[1].childNodes[0].nodeValue
			}
			else if (this.phpXML.childNodes[i].nodeName == "false"){
				this.resultId[i]=false
				this.errorNbr=this.phpXML.childNodes[i].childNodes[0].childNodes[0].nodeValue
				this.errorMessage=this.phpXML.childNodes[i].childNodes[1].childNodes[0].nodeValue			
			}
			else{
				this.resultId[i] = this.phpXML.childNodes[i].nodeName
				this.result[this.phpXML.childNodes[i].nodeName]=this.phpXML.childNodes[i].cloneNode(true)
				this.row[this.resultId[i]]=0
			}
		}
	}
//this is one of two possible fetch functions the user can call to process the SQL result set. It returns an array for one row in the result set. 
// The items in the array are referenced by number in the same order as the columns appear in the SELECT. 
	this.fetchRow = function(resultid){
		if(!this.result[resultid].childNodes[this.row[resultid]]){
			return false				
		}	
		this.resultNum = null	
		this.resultNum = new Array()			
		col=0
		for (j=0;j<this.result[resultid].childNodes[this.row[resultid]].childNodes.length;j++){
			if (this.result[resultid].childNodes[this.row[resultid]].childNodes[j].nodeName !== "#text"){
				this.resultNum[col]=this.result[resultid].childNodes[this.row[resultid]].childNodes[j].childNodes[0].nodeValue
				col++
			}
		}
		this.row[resultid]++		
		return this.resultNum
	}
//this is one of two possible fetch functions the user can call to process the SQL result set. It returns an array for one row in the result set. 
// The items in the array are referenced by column name in the same order as the columns appear in the SELECT. 
	this.fetchAssoc = function(resultid){
		if(!this.result[resultid].childNodes[this.row[resultid]]){
			return false				
		}
		this.resultAssoc = null
		this.resultAssoc = new Array()	
		for (j=0;j<this.result[resultid].childNodes[this.row[resultid]].childNodes.length;j++){
			if (this.result[resultid].childNodes[this.row[resultid]].childNodes[j].nodeName !== "#text"){
				this.resultAssoc[this.result[resultid].childNodes[this.row[resultid]].childNodes[j].nodeName]=this.result[resultid].childNodes[this.row[resultid]].childNodes[j].childNodes[0].nodeValue				
			}
		}
		this.row[resultid]++		
		return this.resultAssoc
	}
//this function allows  the user to reset the row pointer in a result set. After fetching all rows in a result set, the pointer can be set back to the first row with 0 as the rownumber.
	this.dataSeek = function(resultid,rownumber){
		this.row[resultid]=rownumber
		return true
	}
//this function returns the autoincrement id number from the last row inserted that generated an id.
	this.insertId = function(){
		return this.lastId
	}		
//this function returns the number of rows affected by the last insert, delete or update
	this.affectedRows = function(){
		return this.nbrAffectedRows
	}
//this function returns the error number form the last SQL statement that generated an error.
	this.errNo = function(){
		return this.errorNbr
	}	
//this function returns the error number form the last SQL statement that generated an error.
	this.error = function(){
		return this.errorMessage
	}

	
}

