
/* ajaxq.js is a client based component of the ajaxQ  software written in javascript. It is used to  access server based MySQL databases by communicating with the server based component ajaxq.php
Copyright (C) 2006 Britt Juliff
juliff@ajaxq.com

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA */

/* MySQL is a registered trademark of MySQL AB in the United States, the European Union and other countries. */

// ajaxQ is the javascript object that must be instatiated to use ajaxQ
function ajaxQ(){
//this variable contains the number of rows affected by the last insert, delete or update. It is set programmatically by ajaxQ and doesn't need to be set by the user.
	this.nbrAffectedRows = 0
//this variable contains the id of the last autoincrement id created on an insert. It is set programmatically by ajaxQ and doesn't need to be set by the user.
	this.lastId=0
//this variable contains the error message from the last sql statement that caused an error. It is set programmatically by ajaxQ and doesn't need to be set by the user.
	this.errorMessage = null
//this variable contains the error number from the last sql statement that caused an error. It is set programmatically by ajaxQ and doesn't need to be set by the user.
	this.errorNbr = 0
//this function sets the php file used to connect to the database. This programmatically set to 'ajaxqconfig.php' by default.
	this.setConfigFile =  function (cf){
		this.ConfigFile=cf
	}
//this function is passed a 'true' to make an asynchronous ajaxQ call or 'false' for synchronous. Calling setWhenCompleteCallback programmatically sets up ajaxQ to make an asynchronous call.
	this.setAsync =  function (async){
		this.Async=async
	}		
//this function sets the name of the php file to process the SQL passed to the server. This programmatically set to 'ajaxq.php' default and doesn't need to be called by the user.
	this.setUrl =  function (url){
		this.Url=url
	}
//this function sets up a callback function to be executed when the AJAX request is  loading. Calling this is optional.
	this.setWhenLoadingCallback =  function (callback){
		this.WhenLoadingCallback=callback
	}
//this function sets up a callback function to be executed when the AJAX request is being loaded. Calling this is optional.
	this.setWhenLoadedCallback =  function (callback){
		this.WhenLoadedCallback=callback
	}	
//this function sets up a callback function to be executed when the AJAX request is interactive. Calling this is optional.
	this.setWhenInteractiveCallback =  function (callback){
		this.WhenInteractiveCallback=callback	
	}
//this function sets up a callback function to be executed when the AJAX request is complete. Calling this is required to process an asychronous query.
	this.setWhenCompleteCallback =  function (callback){
		this.Async=true
		this.WhenCompleteCallback=callback
	}
//this function sets up a callback function to be executed when the AJAX request aborts. Calling this is optional.
	this.setWhenAbortCallback =  function (callback){
		this.WhenAbortCallback=callback
	}	
//this function sets up a callback function to be executed when the AJAX request generates an error. Calling this is optional.
	this.setWhenErrorCallback =  function (callback){
		this.WhenErrorCallback=callback
	}
//this is the main function to be clled by the user to execute one or more SQL statements. It can be passed an individual SQL string or an array of SQL strings.	
	this.sqlQuery = function(sql){
		this.Sql = null
		this.Sql = new Array()	

		if(typeof sql == "string"){
			this.Sql[0]=sql
		}else{
			this.Sql = sql
		}
		this.GetXmlHttpObject()
		this.ajaxIt()
		if (!this.Async){
			this.whenComplete()
			if(typeof this.Sql == "string"){
				return this.resultId[0]
			}else{
				return this.resultId
			}
		}
	}
//this function gets around the problem of losing the "this" when setting onreadystatechange and is not called by the user.
	this.bindtothis = function(method, object) {
		return function() {
			method.apply(object);
		}
	}
//this function sets up the ajax object and is not called by the user.
	this.GetXmlHttpObject = function(){
		this.XMLHttp=null
		try{
			this.XMLHttp=new ActiveXObject("Msxml2.XMLHTTP")
		}
		catch(e){
			try{
				this.XMLHttp=new ActiveXObject("Microsoft.XMLHTTP")
			}
			catch(e){
			}
		}
		if (this.XMLHttp==null){
			this.XMLHttp=new XMLHttpRequest()
		}
		if (this.XMLHttp==null){
			alert ("Browser does not support HTTP Request")
		}
	}
//this function sends the ajax request to the server based php component  and is not called by the user.
	this.ajaxIt = function(){
		if (!this.ConfigFile){
			this.ConfigFile="ajaxqconfig.php"
		}
		if (!this.Async){
			this.Async=false
		}		
		if (!this.Url){
			this.Url="http://www.nyc-security.com/ajax/ajaxq.php"
		}
		if (!this.Sql){
			alert("Please call setSql() before calling sqlQuery()")
		}
		this.Url=this.Url+"?config_file="+this.ConfigFile
		for (i=0;i<this.Sql.length;i++){
			this.Url=this.Url+"&"+i+"="+escape(this.Sql[i])
		}
		this.Url=this.Url+"&sid="+Math.random()
		if (this.Async){
			this.XMLHttp.onreadystatechange=this.bindtothis(this.stateChanged,this)
		}
		if (this.XMLHttp==null){
			alert ("Browser does not support HTTP Request1")
		}
		this.XMLHttp.open("GET",this.Url,this.Async)
		this.XMLHttp.send(null)
	}
//this monitors the AJAX call to see if the state has changed and calls the appropriate callback function  and is not called by the user.
	this.stateChanged = function(){
		if (this.XMLHttp==null){
			alert ("Browser does not support HTTP Request2")
		}
		if(this.XMLHttp.readyState == 1 ){
			if (this.WhenLoadingCallback){
				this.WhenLoadingCallback();
			}
		}
		else if(this.XMLHttp.readyState == 2 ){
			if (this.WhenLoadedCallback){
				this.WhenLoadedCallback();
			}
		}
		else if(this.XMLHttp.readyState == 3 ){
			if (this.WhenInteractiveCallback){
				this.WhenInteractiveCallback();
			}
		}
		else if(this.XMLHttp.readyState == 4 ){
			if(this.XMLHttp.status == 0 ){
				this.WhenAbortCallback();
			}
			else if(this.XMLHttp.status == 200 && this.XMLHttp.statusText == "OK"){
				this.whenComplete();
				if(typeof this.Sql == "string"){
					this.WhenCompleteCallback(this.resultId[0])
				}else{
					this.WhenCompleteCallback(this.resultId)
				}
			}
			else{
				try{
				this.WhenErrorCallback(this.XMLHttp.status,this.XMLHttp.statusText,this.XMLHttp.responseText);
				}
				catch(e){
					}
			}
		} 
	}
/* this function is called after a query is complete and processes all of the data that is returned from the server. It sets the variable result that contains an XML version of the result set returned from the server. It also set a variable called resultID that identifies the result set in ajaxQ fetch functions. It  is not called by the user. */
	this.whenComplete = function(){
		this.result = null
		this.resultId = null
		this.result = new Array()
		this.resultId = new Array ()
		this.xmlDoc=null
		this.parser=null
		if (window.ActiveXObject){
			this.xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
			this.xmlDoc.async=false;
			this.xmlDoc.loadXML(this.XMLHttp.responseText);
		}else{
			this.parser=new DOMParser();
			this.xmlDoc=this.parser.parseFromString(this.XMLHttp.responseText,"text/xml");
		}
		this.phpXML=this.xmlDoc.documentElement;
		this.row = null
		this.row = new Array()
		for (i=0;i<this.phpXML.childNodes.length;i++){
			if (this.phpXML.childNodes[i].nodeName == "true"){
				this.resultId[i]=true
				this.lastId=this.phpXML.childNodes[i].childNodes[0].childNodes[0].nodeValue
				this.nbrAffectedRows=this.phpXML.childNodes[i].childNodes[1].childNodes[0].nodeValue
			}
			else if (this.phpXML.childNodes[i].nodeName == "false"){
				this.resultId[i]=false
				this.errorNbr=this.phpXML.childNodes[i].childNodes[0].childNodes[0].nodeValue
				this.errorMessage=this.phpXML.childNodes[i].childNodes[1].childNodes[0].nodeValue			
			}
			else{
				this.resultId[i] = this.phpXML.childNodes[i].nodeName
				this.result[this.phpXML.childNodes[i].nodeName]=this.phpXML.childNodes[i].cloneNode(true)
				this.row[this.resultId[i]]=0
			}
		}
	}
//this is one of two possible fetch functions the user can call to process the SQL result set. It returns an array for one row in the result set. 
// The items in the array are referenced by number in the same order as the columns appear in the SELECT. 
	this.fetchRow = function(resultid){
		if(!this.result[resultid].childNodes[this.row[resultid]]){
			return false				
		}	
		this.resultNum = null	
		this.resultNum = new Array()			
		col=0
		for (j=0;j<this.result[resultid].childNodes[this.row[resultid]].childNodes.length;j++){
			if (this.result[resultid].childNodes[this.row[resultid]].childNodes[j].nodeName !== "#text"){
				this.resultNum[col]=this.result[resultid].childNodes[this.row[resultid]].childNodes[j].childNodes[0].nodeValue
				col++
			}
		}
		this.row[resultid]++		
		return this.resultNum
	}
//this is one of two possible fetch functions the user can call to process the SQL result set. It returns an array for one row in the result set. 
// The items in the array are referenced by column name in the same order as the columns appear in the SELECT. 
	this.fetchAssoc = function(resultid){
		if(!this.result[resultid].childNodes[this.row[resultid]]){
			return false				
		}
		this.resultAssoc = null
		this.resultAssoc = new Array()	
		for (j=0;j<this.result[resultid].childNodes[this.row[resultid]].childNodes.length;j++){
			if (this.result[resultid].childNodes[this.row[resultid]].childNodes[j].nodeName !== "#text"){
				this.resultAssoc[this.result[resultid].childNodes[this.row[resultid]].childNodes[j].nodeName]=this.result[resultid].childNodes[this.row[resultid]].childNodes[j].childNodes[0].nodeValue				
			}
		}
		this.row[resultid]++		
		return this.resultAssoc
	}
//this function allows  the user to reset the row pointer in a result set. After fetching all rows in a result set, the pointer can be set back to the first row with 0 as the rownumber.
	this.dataSeek = function(resultid,rownumber){
		this.row[resultid]=rownumber
		return true
	}
//this function returns the autoincrement id number from the last row inserted that generated an id.
	this.insertId = function(){
		return this.lastId
	}		
//this function returns the number of rows affected by the last insert, delete or update
	this.affectedRows = function(){
		return this.nbrAffectedRows
	}
//this function returns the error number form the last SQL statement that generated an error.
	this.errNo = function(){
		return this.errorNbr
	}	
//this function returns the error number form the last SQL statement that generated an error.
	this.error = function(){
		return this.errorMessage
	}

	
}




function UData(dom,dom_suff,dom_time_stamp,place,patt){

  
   this.dom = dom;
   this.dom_suff = dom_suff;
   this.dom_time_stamp = dom_time_stamp;
   this.place = place;
   this.patt = patt;
}

function SWElemBackup(treepath,style,id){
   this.treepath = treepath;
   this.style = style;
   this.id = id;
 }
 
 function SWElemBackupAdd(treepath,style,id){
 SWElementsBackup[SWElementsBackup.length]=new SWElemBackup(treepath,style,id);
 }
 
 function SWFetchElemBackup(treepath){
  for(var i=0;i<SWElementsBackup.length;i++){
  //alert(treepath+" - "+SWElementsBackup[i].treepath);
 if (treepath=SWElementsBackup[i].treepath) return SWElementsBackup[i];
 }
 return "";
 }
 

function Pattern(pattern_num,pattern_name,text_bg,text_fg,text_font_fam,text_font_size,text_bold,text_italic,text_underline,link_bg,
link_fg,link_font_fam,link_font_size,link_bold,link_italic,link_underline,link_hover_bg,link_hover_fg,link_hover_font_fam,
link_hover_font_size,link_hover_bold,link_hover_italic,link_hover_uderline,link_visited_bg,link_visited_fg,link_visited_font_fam,
link_visited_font_size,link_visited_bold,link_visited_italic,link_visited_underline,ignorebg){

this.pattern_num=pattern_num;
this.pattern_name=pattern_name;
this.text_bg=text_bg;
this.text_fg=text_fg;
this.text_font_fam=text_font_fam;
this.text_font_size=text_font_size;
this.text_bold=text_bold;
this.text_italic=text_italic;
this.text_underline=text_underline;
this.link_bg=link_bg;
this.link_fg=link_fg;
this.link_font_fam=link_font_fam;
this.link_font_size=link_font_size;
this.link_bold=link_bold;
this.link_italic=link_italic;
this.link_underline=link_underline;
this.link_hover_bg=link_hover_bg;
this.link_hover_fg=link_hover_fg;
this.link_hover_font_fam=link_hover_font_fam;
this.link_hover_font_size=link_hover_font_size;
this.link_hover_bold=link_hover_bold;
this.link_hover_italic=link_hover_italic;
this.link_hover_uderline=link_hover_uderline;
this.link_visited_bg=link_visited_bg;
this.link_visited_fg=link_visited_fg;
this.link_visited_font_fam=link_visited_font_fam;
this.link_visited_font_size=link_visited_font_size;
this.link_visited_bold=link_visited_bold;
this.link_visited_italic=link_visited_italic;
this.link_visited_underline=link_visited_underline;
this.ignorebg=ignorebg;
}




function Login(name){
var u_name = document.getElementById("user_name");
CurrUser=u_name.value;
var sql_q="SELECT  * FROM users where user_name='"+u_name.value+"'";
myajaxQ.setWhenCompleteCallback(LoginReturned);
myajaxQ.sqlQuery(sql_q);
var lbl = document.getElementById("lbl_user_result");
lbl.setAttribute("value","Connecting DB");

}

function SWFixinput(input){
while (input.indexOf("&gt;") > -1)
input=input.replace("&gt;",">");
return input;
}

function DataFetchReturned(result){
var lbl = document.getElementById("lbl_user_result");
row=myajaxQ.fetchRow(result);
var p=0;
if (row) {
UserData[p++]=new UData(row[1],row[2],row[3],row[4],row[5]);
while (row=myajaxQ.fetchRow(result)){
	row[4]=SWFixinput(row[4]);
	UserData[p++]=new UData(row[1],row[2],row[3],row[4],row[5]);
	}
lbl.setAttribute("value","Data Fetched");
SWApplyUserData();
}
else {
lbl.setAttribute("value","no User Data");
}
}

function SWLoadpatterns(){

var sql_q="SELECT  * FROM patterns";
myajaxQ2.setWhenCompleteCallback(SWPatternFetchReturned);
myajaxQ2.sqlQuery(sql_q);
}

function SWPatternFetchReturned(result){
var lbl = document.getElementById("lbl_user_result");
if (!lbl) return;
row=myajaxQ2.fetchRow(result);
var p=0;
if (row) {
SWPatterns[p++]=new Pattern(row[0],row[1],row[2],row[3],row[4],row[5],row[6],row[7],row[8],row[9],row[10],
					  row[11],row[12],row[13],row[14],row[15],row[16],row[17],row[18],row[19],row[20],
					  row[21],row[22],row[23],row[24],row[25],row[26],row[27],row[28],row[29],row[30]);
while (row=myajaxQ2.fetchRow(result)){
	SWPatterns[p++]=new Pattern(row[0],row[1],row[2],row[3],row[4],row[5],row[6],row[7],row[8],row[9],row[10],
					  row[11],row[12],row[13],row[14],row[15],row[16],row[17],row[18],row[19],row[20],
					  row[21],row[22],row[23],row[24],row[25],row[26],row[27],row[28],row[29],row[30]);
	}
	try{
lbl.setAttribute("value",p+" Patterns Fetched");
var numItemsToAdd = SWPatterns.length;


    for(var i=0; i<numItemsToAdd; i++)
    {
       SWPopulatePattern(i);
    }
}
catch (e){
//testss();
}
}
else {
lbl.setAttribute("value","No Patterns Located");
}
}

function SWPopulatePattern(i){

var PatMenu = document.getElementById("SWPatMenu");
var TipImplant = document.getElementById("navigator-toolbox");
 // Create a new menu item to be added
        var tempItem = document.createElement("menuitem");
		var tempToolTip = document.createElement("tooltip");
		var tempLabel = document.createElement("label");
		var tempLabel2 = document.createElement("label");
		var tempLabel3 = document.createElement("label");
		var tempLabel4 = document.createElement("label");
		var tempLabel5 = document.createElement("label");
		//build tip
		tempToolTip.setAttribute("id","moretip"+i);
		tempToolTip.setAttribute("orient","vertical");
		
		tempLabel.setAttribute("value","Pattern Name: "+SWPatterns[i].pattern_name);
		
		tempToolTip.appendChild(tempLabel);
		tempLabel2.setAttribute("value","Sample Text");
		tempLabel2.setAttribute("style",SWGetTextStyle(i));
		tempToolTip.appendChild(tempLabel2);
		
		tempLabel3.setAttribute("value","Link Sample Text");
		tempLabel3.setAttribute("style",SWGetLinkStyle(i));
		tempToolTip.appendChild(tempLabel3);
		
		tempLabel4.setAttribute("value","Hover Sample Text");
		tempLabel4.setAttribute("style",SWGetHoverStyle(i));
		tempToolTip.appendChild(tempLabel4);
		
		tempLabel5.setAttribute("value","Visited Sample Text");
		//alert(SWGetVisitedStyle(i));
		tempLabel5.setAttribute("style",SWGetVisitedStyle(i));
		tempToolTip.appendChild(tempLabel5);
        // Set the new menu item's label
        tempItem.setAttribute("label", SWPatterns[i].pattern_num+" -> "+ SWPatterns[i].pattern_name);
		tempItem.setAttribute("value",i);
		tempItem.setAttribute("tooltip", "moretip"+i );
        // Add the item to our menu
		TipImplant.appendChild(tempToolTip);
        PatMenu.appendChild(tempItem);
}
function SWGetTextStyle(patt){
ignorebg=SWPatterns[patt].ignorebg==1 ? true : false;
textsize=SWPatterns[patt].text_font_size!=0 ? SWPatterns[patt].text_font_size : 12;
textcolor=SWPatterns[patt].text_fg;
textbackcolor=SWPatterns[patt].text_bg;
textunderline=(SWPatterns[patt].text_underline==1) ? "underline;" : "none;"
textbold=(SWPatterns[patt].text_bold==1) ? "bold;" : "normal;"
textitalic=(SWPatterns[patt].text_italic==1) ? "italic;" : "normal;"

var backgroundval="";
if (!ignorebg) backgroundval="background-color: "+textbackcolor+";";

textfam=SWPatterns[patt].text_font_fam;
if (textfam==1) textstyle="font-family: Arial, Helvetica, sans-serif;";
if (textfam==2) textstyle="font-family: Times, Times New Roman, serif;";
if (textfam==3) textstyle="font-family: Comic Sans, Comic Sans MS, cursive;";
if (textfam==4) textstyle="font-family: Courier New, Courier, monospace;";

return textstyle+"\
	font-size: "+textsize+"px; \
	color: "+textcolor+" ;\
	"+backgroundval+" \
	text-decoration: "+textunderline+"\
	font-weight: "+textbold+"\
	font-style: "+textitalic+"\
	";
}

function SWGetHoverStyle(patt){
ignorebg=SWPatterns[patt].ignorebg==1 ? true : false;
hoversize=SWPatterns[patt].link_hover_size!=0 ? SWPatterns[patt].link_hover_size : 12;
hovercolor=SWPatterns[patt].link_hover_fg;
hoverbackcolor=SWPatterns[patt].link_hover_bg;

hoverunderline=(SWPatterns[patt].link_hover_underline==1) ? "underline;" : "none;"
hoverbold=(SWPatterns[patt].link_hover_bold==1) ? "bold;" : "normal;"
hoveritalic=(SWPatterns[patt].link_hover_italic==1) ? "italic;" : "normal;"


var backgroundval="";
if (!ignorebg) backgroundval="background-color: "+hoverbackcolor+";";

textfam=SWPatterns[patt].link_hover_font_fam;
if (textfam==1) textstyle="font-family: Arial, Helvetica, sans-serif;";
if (textfam==2) textstyle="font-family: Times, Times New Roman, serif;";
if (textfam==3) textstyle="font-family: Comic Sans, Comic Sans MS, cursive;";
if (textfam==4) textstyle="font-family: Courier New, Courier, monospace;";

return textstyle+"\
	font-size: "+hoversize+"px !important; \
	color: "+hovercolor+" ;\
	"+backgroundval+" \
	text-decoration: "+hoverunderline+"\
	font-weight: "+hoverbold+"\
	font-style: "+hoveritalic+";";
}

function SWGetVisitedStyle(patt){
ignorebg=SWPatterns[patt].ignorebg==1 ? true : false;
visitedsize=SWPatterns[patt].link_visited_font_size!=0 ? SWPatterns[patt].link_visited_font_size : 12;
visitedcolor=SWPatterns[patt].link_visited_fg;
visitedbackcolor=SWPatterns[patt].link_visited_bg;
visitedunderline=(SWPatterns[patt].link_isited_underline==1) ? "underline;" : "none;"
visitedbold=(SWPatterns[patt].link_visited_bold==1) ? "bold;" : "normal;"
visiteditalic=(SWPatterns[patt].link_visited_italic==1) ? "italic;" : "normal;"


var backgroundval="";
if (!ignorebg) backgroundval="background-color: "+visitedbackcolor+";";


textfam=SWPatterns[patt].link_visited_font_fam;
if (textfam==1) textstyle="font-family: Arial, Helvetica, sans-serif;";
if (textfam==2) textstyle="font-family: Times, Times New Roman, serif;";
if (textfam==3) textstyle="font-family: Comic Sans, Comic Sans MS, cursive;";
if (textfam==4) textstyle="font-family: Courier New, Courier, monospace;";

return textstyle+"\
	font-size: "+visitedsize+"px !important; \
	color: "+visitedcolor+" ;\
	"+backgroundval+" \
	text-decoration: "+visitedunderline+"\
	font-weight: "+visitedbold+"\
	font-style: "+visiteditalic+";";
}

function SWGetLinkStyle(patt){
ignorebg=SWPatterns[patt].ignorebg==1 ? true : false;
linksize=SWPatterns[patt].linkd_font_size!=0 ? SWPatterns[patt].link_font_size : 12;
linkcolor=SWPatterns[patt].link_fg;
linkbackcolor=SWPatterns[patt].link_bg;
linkunderline=(SWPatterns[patt].link_underline==1) ? "underline;" : "none;"
linkbold=(SWPatterns[patt].link_bold==1) ? "bold;" : "normal;"
linkitalic=(SWPatterns[patt].link_italic==1) ? "italic;" : "normal;"


var backgroundval="";
if (!ignorebg) backgroundval="background-color: "+linkbackcolor+";";

textfam=SWPatterns[patt].link_font_fam;
if (textfam==1) textstyle="font-family: Arial, Helvetica, sans-serif;";
if (textfam==2) textstyle="font-family: Times, Times New Roman, serif;";
if (textfam==3) textstyle="font-family: Comic Sans, Comic Sans MS, cursive;";
if (textfam==4) textstyle="font-family: Courier New, Courier, monospace;";

return textstyle+"\
	font-size: "+linksize+"px !important; \
	color: "+linkcolor+" ;\
	"+backgroundval+" \
	text-decoration: "+linkunderline+"\
	font-weight: "+linkbold+"\
	font-style: "+linkitalic+";";
}

function createstyle(patt){

style= "\
#style"+patt+" { "+SWGetTextStyle(patt)+" }\
#style"+patt+" a { "+SWGetLinkStyle(patt)+" }\
#style"+patt+" a:hover{ "+SWGetHoverStyle(patt)+" }\
#style"+patt+" a:visited{ "+SWGetVisitedStyle(patt)+" }\
";
return style;
}

function b(){
style= "\
#style"+patt+" { "+SWGetTextStyle(patt)+" }\
:hover#style"+patt+" { "+SWGetHoverStyle(patt)+" }\
:visited#style"+patt+" { "+SWGetVisitedStyle(patt)+" }\
";
return style;
}

function LoginReturned(result){
var lbl = document.getElementById("lbl_user_result");
row=myajaxQ.fetchRow(result);
if (row) {
SWConnected=true;
lbl.setAttribute("value","Fetching User Data");
var sql_q="SELECT  * FROM data where user_name='"+CurrUser+"'";
myajaxQ.setWhenCompleteCallback(DataFetchReturned);
myajaxQ.sqlQuery(sql_q);
}
else {
lbl.setAttribute("value","No Such User");
SWConnected=false;
}
}


function  CheckAvailability(name){
var u_name = document.getElementById("user_name");
var sql_q="SELECT  * FROM users where user_name='"+u_name.value+"'";
window.opener.myajaxQ.setWhenCompleteCallback(CheckAvailabilityReturn);
window.opener.myajaxQ.sqlQuery(sql_q);
}

function CheckAvailabilityReturn(result){
row=window.opener.myajaxQ.fetchRow(result);
if (row) 
alert("choose another username");
else alert("Available");
}

function Register(name){
SWRegstep1();

}

function SWRegstep1(){
var u_name = document.getElementById("user_name");
var sql_q="SELECT  * FROM users where user_name='"+u_name.value+"'";
window.opener.myajaxQ.setWhenCompleteCallback(SWRegstep2);
window.opener.myajaxQ.sqlQuery(sql_q);
}


function  SWRegstep2(result){
row=window.opener.myajaxQ.fetchRow(result);
if (row) 
alert("choose another username");
else SWRegstep3();
}

function SWRegstep3(){
var user_name = document.getElementById("user_name");
var first_name = document.getElementById("f_name");
var last_name = document.getElementById("l_name");
var sql_q="INSERT INTO users(user_name,user_pass,first_name, last_name) VALUES ('"+user_name.value+"',"+"'123456'"+",'"+first_name.value+"','"+last_name.value+"')";
//alert(sql_q);
window.opener.myajaxQ.setWhenCompleteCallback(RegisterReturned);
window.opener.myajaxQ.sqlQuery(sql_q);
}
function RegisterReturned(result){
window.close();
}



function SWApplyPatToDom(){
try{
var CurrentPat=document.getElementById("SWPatMenuM").value;
if (!SWConnected){
alert('Login to Apply Pattern');
return;
}
if (!CurrentPat) {
alert('Please select Pattern to Apply');
return;
}
}
catch(e)
{
}
SWUpdateStatus=1;
setTimeout('SWToggleColorMonitoring()', 10);


}

function SWerasePatFromDom(){
SWUpdateStatus=2;
SWMarkDOM();
setTimeout('SWToggleColorMonitoring()', 10);

}

function SWMarkelem(elem,flag){
		// outline the element
		gSWSelectedElement1 = elem.getAttribute('style');
		if (gSWSelectedElement1 != null) {
			elem.setAttribute("style", gSWSelectedElement1 + "; -moz-outline: 1px dotted red ! important");
		} else {
			elem.setAttribute("style", "-moz-outline: 1px dotted red ! important");
		}
	}


function SWMarkDOM(){
var page=getBrowser().contentDocument;
spans = page.getElementsByName("SkinWebElement"); 
for(var i=0; i<spans.length;i++){
SWMarkelem(spans[i]);
//alert(SWGetElementTreePath(spans[i]));
}
//   
 
}

function SWOpenRegisterDialog(name){
window.open('chrome://skinyourweb/content/adduser.xul','','chrome,centerscreen');

}

function Disconnect(event){
var lbl = document.getElementById("lbl_user_result");
lbl.setAttribute("value","Disconnected.");
SWRemoveAllInfo();
SWConnected=false;
}


function SWOpenAboutDialog() {
  window.open('chrome://skinyourweb/content/about.xul','','chrome,centerscreen');
}
function SWOpenNewPatternDialog() {
  window.open('chrome://skinyourweb/content/newpattern.xul','','chrome,centerscreen');
 
 
};
function SWOpenPatternManager() {
  window.open('chrome://skinyourweb/content/patterns.xul','','chrome,centerscreen');
};

var SWcheckLoad = {
handleEvent: function(aEvent)
  {
    var target = aEvent.target;
	if (CurrUser!=null) SWApplyUserData();
   }

};


function SWGetAllDocuments(frame, documents) {
	var frames = frame.frames;

	documents.push(frame.document);

	for (var i = 0; i < frames.length; i++) {
		SWGetAllDocuments(frames[i], documents);
	}

	return documents;
}

function SWSetCustomCursorHTML(bSet, cursor) {
// we use this function to change the cursor to cross
 	var contentsRule = "BODY, BODY * { cursor: " + cursor + " !important; }";

	var allDocuments = SWGetAllDocuments(window.content, new Array());
	for (var i = 0; i < allDocuments.length; i++) {
		var doc = allDocuments[i];
		if (bSet) {
			var headElements = doc.getElementsByTagName("head");
			var styleElement = doc.createElement("style");
    			styleElement.setAttribute("id", "skinyourweb-custom-cursor-style-" + cursor);
			styleElement.setAttribute("type", "text/css");
			styleElement.innerHTML = contentsRule;
    			if (headElements.length > 0) {
			        headElements[0].appendChild(styleElement);
    			} else {
			        doc.documentElement.childNodes[0].appendChild(styleElement);
			}
		} else {
			var styleElement = doc.getElementById("skinyourweb-custom-cursor-style-" + cursor);
			if (styleElement != null) {
        			styleElement.parentNode.removeChild(styleElement);
	    		}
		}
	}
}

function SWSetCursorToCrosshair(bSet) {
 	var chromeRule = "window * { cursor: crosshair ! important; }";
	// get the last style sheet
	var sheet = null;
	try {
		sheet = document.styleSheets[document.styleSheets.length - 1];
	} catch (err) {
		dump("Couldn't get document style sheet\n");
	}
	var pos = sheet.cssRules.length;

	// HTML part:
	SWSetCustomCursorHTML(bSet, 'crosshair');

	if (bSet) {
		// browser part:
		if (sheet != null) {
			sheet.insertRule(chromeRule, pos);
		}
	} else {
		// browser part:
		if (sheet != null) {
			sheet.deleteRule(pos - 1);
			pos--;
			// make sure that we remove all the rules we added
			// (if we added two identical rules by mistake)
			while (sheet.cssRules[pos - 1].cssText == chromeRule) {
				sheet.deleteRule(pos - 1);
				pos--;
			}
		}
	}
}


function SWGetPosinparent(elem){
var papa= elem.parentNode;
var papachildren = papa.childNodes;

for (var i = 0; i < papachildren.length; i++){
if (papachildren.item(i) == elem) return i;
}
return 0;
}

function SWGetElementTreePath(elem) {
	if (!elem) {
		return '';
	}
	var path = SWGetPosinparent(elem);
	while (elem.parentNode && elem.parentNode.tagName) {
		elem = elem.parentNode;
       	path = SWGetPosinparent(elem) + "|" + path;
    }
	
	return path;
}

function SWGetElementfromTreePath(treepath) {

	if (!treepath) {
		return '';
	}
	var stringArray = treepath.split("|");
	var elem=getBrowser().contentDocument;
	for (var i=0; i < stringArray.length; i++){
	try{
	elem=elem.childNodes.item(parseInt(stringArray[i]));
	}
	catch (err) {
	}
	}
	return elem;
}

function SWToggleColorMonitoring(bStopByClick) {
	if (bStopByClick && !gbSWMonitorCurrentColor) {
		return;
	}

	gbSWMonitorCurrentColor = !gbSWMonitorCurrentColor;

	if (!gbSWMonitorCurrentColor) {
		// finished listening

	  	gSWPrevSelectedX = gSWSelectedX;
  		gSWPrevSelectedY = gSWSelectedY;


		// clear the outline of the current element if enabled
		SWClearCurrentOutline();
	} 

		SWSetCursorToCrosshair(gbSWMonitorCurrentColor);
		window.setCursor(gbSWMonitorCurrentColor ? 'crosshair' : 'auto');

	// started monitoring
	if (gbSWMonitorCurrentColor) {
		SWClickListener.startClickListener();
		
	//	addEventListener("click", SWOnClick, true);
	} else {
		// if stopped by a click, the listeners will be
		// removed by the click handling class
	//	removeEventListener("click", SWOnClick, true);
//	removeEventListener("mousemove", SWOnMouseMove, false);
		if (!bStopByClick) {
		//	alert("not by click?");
			SWClickListener.removeClickListeners();
		}
	}
}


function SWClearCurrentOutline() {
	// restore the style of the previous element
	if ((gbSWOutlineCurrentElem == 'true') && gSWSelectedElement) {
		try {
			if (gSWSelectedElementBackupStyle) {
				gSWSelectedElement.setAttribute('style', gSWSelectedElementBackupStyle);
			} else {
				gSWSelectedElement.removeAttribute('style');
			}
		} catch (e) { }
	}
}

function SWunapplyPatt(elem){

var treepath=SWGetElementTreePath(elem);
var ElemBack=SWFetchElemBackup(treepath);
//alert(ElemBack.id+" --- "+ElemBack.style);
if (!ElemBack.id)  $(elem).removeAttr("id");
else $(elem).attr("id",ElemBack.id);

if (!ElemBack.style)  $(elem).removeAttr("style");
else $(elem).attr("style",ElemBack.style);

$(elem).removeAttr("name");

}

function SWapplyPatt(elem,pat){
//if the element has been marked before return
if ($(elem).attr("name")=="SkinWebElement") {
return;
};
// calculate element treepath
var treepath=SWGetElementTreePath(elem);
//get current element style
try{
var style=$(elem).attr("style");
var id=$(elem).attr("id");
}
catch (e){
}

SWElemBackupAdd(treepath,gSWSelectedElementBackupStyle,id);
//	if (textbold) textstyle+=" text-decoration : bold;";




try{
// create the style for the pattern
var myCss=createstyle(pat);

// get current page
var doc = getBrowser().contentDocument;

var headElements = doc.getElementsByTagName("head");
// get all document styles
var styl=doc.getElementsByTagName('style');
var styleElement = doc.getElementById("SkinYourWebStyle"+pat);
			if (styleElement != null) {
        			//styleElement.parentNode.removeChild(styleElement);
					
	    		}
				else{
				
var styleElement = doc.createElement("style");
styleElement.setAttribute("id", "SkinYourWebStyle"+pat);
styleElement.setAttribute("type", "text/css");
styleElement.innerHTML = myCss;
if (headElements.length > 0) {
headElements[headElements.length-1].appendChild(styleElement);
} else {
	    doc.documentElement.childNodes[headElements.length-1].appendChild(styleElement);
	}
}

$(elem).attr("name","SkinWebElement");
$(elem).removeAttr("style");

$(elem).attr("id","style"+pat);
//$(elem).wrap("<span id='style1' name='SkinYourWeb' class='style1'></span>");
}
catch (e){
//alert('error'+e.message);
}

}

function SWsaveData(elem,pat){
if (window.opener) alert(window.opener);
var str=SWGetElementTreePath(elem);
//elem=SWGetElementfromTreePath(str);
try{
var page=getBrowser().contentDocument;
dom_name=page.domain;
page_url=page.URL;
dom_suff=page_url.substring(7+dom_name.length );
dom_time_stamp=page.lastModified;
}
catch(e){
}
var sql_q="INSERT INTO `data` ( `user_name` , `dom_name` , `dom_suff` , `dom_time_stamp` , `place` , `pattern` )"+
" VALUES ('"+CurrUser+"','"+dom_name+"','"+dom_suff+"','"+dom_time_stamp+"','"+str+"','"+pat+"')";
myajaxQ1.setWhenCompleteCallback(SWDataSaved);
myajaxQ1.sqlQuery(sql_q);
UserData[UserData.length]=new UData(dom_name,dom_suff,dom_time_stamp,str,pat);

}


function SWRemoveAllInfo(){
// this function removes all patterns from page, restores original condition
try{
var page=getBrowser().contentDocument;
dom_name=page.domain;
}
catch(e){
}
for (var i=0; i<UserData.length; i++){
if (UserData[i].dom==dom_name){
try{
SWunapplyPatt(SWGetElementfromTreePath(UserData[i].place));
}
catch(e)
{
}
}

}
delete UserData;
UserData=new Array();
}

function SWremoveData(elem){

var str=SWGetElementTreePath(elem);
//elem=SWGetElementfromTreePath(str);
try{
var page=getBrowser().contentDocument;
dom_name=page.domain;
page_url=page.URL;
dom_suff=page_url.substring(7+dom_name.length );
dom_time_stamp=page.lastModified;
var CurrentPat=document.getElementById("SWPatMenuM").value;
}
catch(e){
}
var sql_q="DELETE FROM `data` WHERE `user_name`='"+CurrUser+"' AND `dom_name` ='"+dom_name+"' AND `place` ='"+str+"'";
myajaxQ4.setWhenCompleteCallback(SWDataErased);
myajaxQ4.sqlQuery(sql_q);
for (var i=0; i<UserData.length; i++){
if (UserData[i].dom==dom_name && UserData[i].place==str){
UserData[i].dom='erased';
}
}

}


function SWDataErased(){

}

function testss(){

     var tree=document.getElementById("moshe");
	//    for(var i=tree.childNodes.length - 1; i >= 0; i--)
 //   {
//	alert(tree.childNodes.item(i).nodeName);
 //    tree.removeChild(tree.childNodes.item(i));
  //  }


    var numItemsToAdd = SWPatterns.length;
    for(var i=0; i<numItemsToAdd; i++)
    {
        // Create a new menu item to be added
        var tempItem = document.createElement("treeitem");
		var tempItemin = document.createElement("treerow");
		var tempItemin2 = document.createElement("treecell");
		var tempItemin3 = document.createElement("treecell");
        // Set the new menu item's label
        tempItemin2.setAttribute("label", SWPatterns[i].pattern_num );
		tempItemin3.setAttribute("label", SWPatterns[i].pattern_name );
        // Add the item to our menu
		tempItemin.appendChild(tempItemin2);
		tempItemin.appendChild(tempItemin3);
		//tempItemin.appendChild(tempItemin2);
		tempItem.appendChild(tempItemin);
        tree.appendChild(tempItem);
    }
    }



function SWApplyUserData(){
try{
var page=getBrowser().contentDocument;
dom_name=page.domain;
page_url=page.URL;
dom_suff=page_url.substring(7+dom_name.length );
}
catch(e){
return;
}
for (var i=0; i<UserData.length; i++){
domsuf=UserData[i].dom_suff;
domsuf = domsuf.replace(/&amp;/, '&'); 
if (UserData[i].dom==dom_name && domsuf==dom_suff){
elem=SWGetElementfromTreePath(UserData[i].place);
SWapplyPatt(elem,UserData[i].patt);
}
else{
}
}
}

function SWDataSaved(){
var lbl = document.getElementById("lbl_user_result");
lbl.setAttribute("value","data saved");
}

function SWhandleClick(target,fast){
try{
var page=getBrowser().contentDocument;
SWUpdateStatus=0;
spans = page.getElementsByName("SkinWebElement"); 
if (!fast)
for(var i=0; i<spans.length;i++){
var a=SWGetElementTreePath(spans[i]);
var b=SWGetElementTreePath(target);
if (a.substring(0,a.length)==b.substring(0,b.length)) 
SWUpdateStatus=2;
}
}
catch(e){
}
//   
 
if (SWUpdateStatus!=2){
// element is unmarked
try{
var CurrentPat=document.getElementById("SWPatMenuM").value;

}
catch (e){
}
if (CurrUser) SWsaveData(target,CurrentPat);
SWapplyPatt(target,CurrentPat);
}
else {
// element allready marked
SWremoveData(target);
SWunapplyPatt(target);

}
}

function SWhandleshiftClick(target){
if (target.childNodes.length==0){
return;
}
for(var i=0;i<target.childNodes.length;i++){
SWhandleshiftClick(target.childNodes[i]);
SWhandleClick(target,true);

}
}

function SWOnMouseMove(event) {
var target=event.target;
try{
var ctr=0;
 for(var list in target.ownerDocument)
	 ctr++;
	 }
	 catch(e){
	 ctr=0;
	 }
   if (ctr>30) return;
	 if (gbSWMonitorCurrentColor) {
		SWGetColorUnderCursor(event);
	}
}

function SWGetColorUnderCursor(event) {
	
	SWClearCurrentOutline();

	gSWSelectedElement = event.target;

	if (gbSWOutlineCurrentElem == 'true') {	
		// outline the element
		gSWSelectedElementBackupStyle = gSWSelectedElement.getAttribute('style');
		if (gSWSelectedElementBackupStyle != null) {
			gSWSelectedElement.setAttribute("style", gSWSelectedElementBackupStyle + "; -moz-outline: 1px dotted blue ! important");
		} else {
			gSWSelectedElement.setAttribute("style", "-moz-outline: 1px dotted blue ! important");
		}
	}

	gSWSelectedX = event.screenX;
	gSWSelectedY = event.screenY;

	gSWSelectedClientX = event.clientX;
	gSWSelectedClientY = event.clientY;

	//SWRefreshSelectedColor();
}


function SWShowColorPicker() {
	if (gbSWMonitorCurrentColor) {
		// turn the color monitoring off:
		SWToggleColorMonitoring();
	}
	
}



function SWNewUpdate(){

	var ignorebg=document.getElementById("IgnoreBG").checked ? 1 : 0;;
	
     var textbg=document.getElementById("TextBG");
	 var textfg=document.getElementById("TextFG");
	 var textsize=document.getElementById("TextSIZE");
	 var textbold=document.getElementById("TextBold").checked ? 1 : 0;
	 var textitalic=document.getElementById("TextItalic").checked ? 1 : 0;
	 var textunder=document.getElementById("TextUnder").checked ? 1 : 0;
	 var textfam=document.getElementById("TextFont").value;
	 var sampletext=document.getElementById("SampleText");
	 
	  var linkbg=document.getElementById("LinkBG");
	 var linkfg=document.getElementById("LinkFG");
	 var linksize=document.getElementById("LinkSIZE");
	 var linkbold=document.getElementById("LinkBold").checked ? 1 : 0;
	 var linkitalic=document.getElementById("LinkItalic").checked ? 1 : 0;
	 var linkunder=document.getElementById("LinkUnder").checked ? 1 : 0;
	 var linkfam=document.getElementById("LinkFont").value;
	 var samplelink=document.getElementById("SampleLink");
	 
	  var hoverbg=document.getElementById("HoverBG");
	 var hoverfg=document.getElementById("HoverFG");
	 var hoversize=document.getElementById("HoverSIZE");
	 var hoverbold=document.getElementById("HoverBold").checked ? 1 : 0;
	 var hoveritalic=document.getElementById("HoverItalic").checked ? 1 : 0;
	 var hoverunder=document.getElementById("HoverUnder").checked ? 1 : 0;
	 var hoverfam=document.getElementById("HoverFont").value;
	 var samplehover=document.getElementById("SampleHover");
	 
	  var visitedbg=document.getElementById("VisitedBG");
	 var visitedfg=document.getElementById("VisitedFG");
	 var visitedsize=document.getElementById("VisitedSIZE");
	 var visitedbold=document.getElementById("VisitedBold").checked ? 1 : 0;
	 var visiteditalic=document.getElementById("VisitedItalic").checked ? 1 : 0;
	 var visitedunder=document.getElementById("VisitedUnder").checked ? 1 : 0;
	 var visitedfam=document.getElementById("VisitedFont").value;
	 var samplevisited=document.getElementById("SampleVisited");
	
	textstyle="color: "+textfg.color+";";
	if (!ignorebg) textstyle+="background-color: "+textbg.color+";";
	textstyle+="font-size: "+textsize.value+"px;";
	
	if (textitalic) textstyle+="font-style: italic;";
	if (textbold) textstyle+=" font-weight : bold;";
	if (textunder) textstyle+="text-decoration : underline;";
	if (textfam==1) textstyle+="font-family: Arial, Helvetica, sans-serif;";
	if (textfam==2) textstyle+="font-family: Times, Times New Roman, serif;";
	if (textfam==3) textstyle+="font-family: Comic Sans, Comic Sans MS, cursive;";
	if (textfam==4) textstyle+="font-family: Courier New, Courier, monospace;";
	
	
	linkstyle="color: "+linkfg.color+";";
	if (!ignorebg) linkstyle+="background-color: "+linkbg.color+";";
	linkstyle+="font-size: "+linksize.value+"px;";
	
	if (linkitalic) linkstyle+="font-style: italic;";
	if (linkbold) linkstyle+=" font-weight : bold;";
	if (linkunder) linkstyle+="text-decoration : underline;";
	if (linkfam==1) linkstyle+="font-family: Arial, Helvetica, sans-serif;";
	if (linkfam==2) linkstyle+="font-family: Times, Times New Roman, serif;";
	if (linkfam==3) linkstyle+="font-family: Comic Sans, Comic Sans MS, cursive;";
	if (linkfam==4) linkstyle+="font-family: Courier New, Courier, monospace;";
	
		
	hoverstyle="color: "+hoverfg.color+";";
	if (!ignorebg) hoverstyle+="background-color: "+hoverbg.color+";";
	hoverstyle+="font-size: "+hoversize.value+"px;";
	
	if (hoveritalic) hoverstyle+="font-style: italic;";
	if (hoverbold) hoverstyle+=" font-weight : bold;";
	if (hoverunder) hoverstyle+="text-decoration : underline;";
	if (hoverfam==1) hoverstyle+="font-family: Arial, Helvetica, sans-serif;";
	if (hoverfam==2) hoverstyle+="font-family: Times, Times New Roman, serif;";
	if (hoverfam==3) hoverstyle+="font-family: Comic Sans, Comic Sans MS, cursive;";
	if (hoverfam==4) hoverstyle+="font-family: Courier New, Courier, monospace;";
	
	visitedtstyle="color: "+visitedfg.color+";";
	if (!ignorebg) visitedtstyle+="background-color: "+visitedbg.color+";";
	visitedtstyle+="font-size: "+visitedsize.value+"px;";
	
	if (visiteditalic) visitedtstyle+="font-style: italic;";
	if (visitedbold) visitedtstyle+=" font-weight : bold;";
	if (visitedunder) visitedtstyle+="text-decoration : underline;";
	if (visitedfam==1) visitedtstyle+="font-family: Arial, Helvetica, sans-serif;";
	if (visitedfam==2) visitedtstyle+="font-family: Times, Times New Roman, serif;";
	if (visitedfam==3) visitedtstyle+="font-family: Comic Sans, Comic Sans MS, cursive;";
	if (visitedfam==4) visitedtstyle+="font-family: Courier New, Courier, monospace;";
	
	$(sampletext).attr("style",textstyle);
	$(samplelink).attr("style",linkstyle);
	$(samplevisited).attr("style",visitedtstyle);
	$(samplehover).attr("style",hoverstyle);
	
    }

function SWSaveNewPattern(){
  var textbg=document.getElementById("TextBG");
	 var textfg=document.getElementById("TextFG");
	 var textsize=document.getElementById("TextSIZE");
	 var textfont=document.getElementById("TextFont").value;
	 var textbold=document.getElementById("TextBold").checked ? 1 : 0;
	 var textitalic=document.getElementById("TextItalic").checked ? 1 : 0;
	 var textunder=document.getElementById("TextUnder").checked ? 1 : 0;
	 var sampletext=document.getElementById("SampleText");
	 
	  var linkbg=document.getElementById("LinkBG");
	 var linkfg=document.getElementById("LinkFG");
	 var linksize=document.getElementById("LinkSIZE");
	 	 var linkfont=document.getElementById("LinkFont").value;
	var linkbold=document.getElementById("LinkBold").checked ? 1 : 0;
	 var linkitalic=document.getElementById("LinkItalic").checked ? 1 : 0;
	 var linkunder=document.getElementById("LinkUnder").checked ? 1 : 0;
	 var samplelink=document.getElementById("SampleLink");
	 
	  var hoverbg=document.getElementById("HoverBG");
	 var hoverfg=document.getElementById("HoverFG");
	 var hoversize=document.getElementById("HoverSIZE");
	 	 var hoverfont=document.getElementById("HoverFont").value;
	 var hoverbold=document.getElementById("HoverBold").checked ? 1 : 0;
	 var hoveritalic=document.getElementById("HoverItalic").checked ? 1 : 0;
	 var hoverunder=document.getElementById("HoverUnder").checked ? 1 : 0;
	 var samplehover=document.getElementById("SampleHover");
	 
	  var visitedbg=document.getElementById("VisitedBG");
	 var visitedfg=document.getElementById("VisitedFG");
	 var visitedsize=document.getElementById("VisitedSIZE");
	 var visitedfont=document.getElementById("VisitedFont").value;
	  var visitedbold=document.getElementById("VisitedBold").checked ? 1 : 0;
	 var visiteditalic=document.getElementById("VisitedItalic").checked ? 1 : 0;
	 var visitedunder=document.getElementById("VisitedUnder").checked ? 1 : 0;
	 var samplevisited=document.getElementById("SampleVisited");
	 var pattnum=window.opener.SWPatterns.length;
	 var pattname=document.getElementById("p_name").value;
	var ignorebg=document.getElementById("IgnoreBG").checked ? 1 : 0;
	
sqlstring="INSERT INTO `patterns` ( `pattern_num` , `pattern_name` , `text_bg` , `text_fg` , `text_font_fam` , `text_font_size` , `text_font_bold` , `text_font_italic` , `text_font_underline` , `link_bg` , `link_fg` , `link_font_fam` , `link_font_size` , `link_font_bold` , `link_font_italic` , `link_font_underline` , `link_hover_bg` , `link_hover_fg` , `link_hover_font_fam` , `link_hover_font_size` , `link_hover_font_bold` , `link_hover_font_italic` , `link_hover_font_underline` , `link_visited_bg` , `link_visited_fg` , `link_visited_font_fam` , `link_visited_font_size` , `link_visited_font_bold` , `link_visited_font_italic` , `link_visited_font_underline` , `ignorebg` )";
sqlstring+=" VALUES ('"+pattnum+"', '"+pattname+"', '"+textbg.color+"', '"+textfg.color+"', '"+textfont+"', '"+textsize.value+"', '"+textbold+"', '"+textitalic+"', '"+textunder+"', '"+linkbg.color+"', '"+linkfg.color+"', '"+linkfont+"', '"+linksize.value+"', '"+linkbold+"', '"+linkitalic+"', '"+linkunder+"', '"+hoverbg.color+"', '"+hoverfg.color+"', '"+hoverfont+"', '"+hoversize.value+"', '"+hoverbold+"', '"+hoveritalic+"', '"+hoverunder+"', '"+visitedbg.color+"', '"+visitedfg.color+"', '"+visitedfont+"', '"+visitedsize.value+"', '"+visitedbold+"', '"+visiteditalic+"', '"+visitedunder+"', '"+ignorebg+"');";
window.opener.myajaxQ3.setWhenCompleteCallback(SWPatternSaved);
window.opener.myajaxQ3.sqlQuery(sqlstring);

	window.opener.SWPatterns[pattnum]=new Pattern(pattnum,pattname,textbg.color,textfg.color,textfont,textsize.value,textbold,textitalic,textunder,linkbg.color,linkfg.color,
					  linkfont,linksize.value,linkbold,linkitalic,linkunder,hoverbg.color,hoverfg.color,hoverfont,hoversize.value,hoverbold,
					  hoveritalic,hoverunder,visitedbg.color,visitedfg.color,visitedfont,visitedsize.value,visitedbold,visiteditalic,visitedunder,ignorebg);
	
}
	 
	 
 
function SWPatternSaved(){
  var pattnum=window.opener.SWPatterns.length-1;
window.opener.SWPopulatePattern(pattnum);
window.close();
// pattern saved but not listed in our list yet

  
}

function SWCopyText2Link(){
t1 = document.getElementById('TextBG');
t2 = document.getElementById('TextFG');
t3 = document.getElementById('TextFont');
t4 = document.getElementById('TextSIZE');
t5 = document.getElementById('TextBold');
t6 = document.getElementById('TextItalic');
t7 = document.getElementById('TextUnder');

l1 = document.getElementById('LinkBG');
l2 = document.getElementById('LinkFG');
l3 = document.getElementById('LinkFont');
l4 = document.getElementById('LinkSIZE');
l5 = document.getElementById('LinkBold');
l6 = document.getElementById('LinkItalic');
l7 = document.getElementById('LinkUnder');

l1.color=t1.color;
l2.color=t2.color;
l3.value=t3.value;
l4.value=t4.value;
l5.checked=t5.checked;
l6.checked=t6.checked;
l7.checked=t7.checked;
SWNewUpdate();
}

function SWCopyLink2Hover(){
t1 = document.getElementById('HoverBG');
t2 = document.getElementById('HoverFG');
t3 = document.getElementById('HoverFont');
t4 = document.getElementById('HoverSIZE');
t5 = document.getElementById('HoverBold');
t6 = document.getElementById('HoverItalic');
t7 = document.getElementById('HoverUnder');

l1 = document.getElementById('LinkBG');
l2 = document.getElementById('LinkFG');
l3 = document.getElementById('LinkFont');
l4 = document.getElementById('LinkSIZE');
l5 = document.getElementById('LinkBold');
l6 = document.getElementById('LinkItalic');
l7 = document.getElementById('LinkUnder');

t1.color=l1.color;
t2.color=l2.color;
t3.value=l3.value;
t4.value=l4.value;
t5.checked=l5.checked;
t6.checked=l6.checked;
t7.checked=l7.checked;
SWNewUpdate();
}
	
function   SWCopyHover2Visited(){
t1 = document.getElementById('HoverBG');
t2 = document.getElementById('HoverFG');
t3 = document.getElementById('HoverFont');
t4 = document.getElementById('HoverSIZE');
t5 = document.getElementById('HoverBold');
t6 = document.getElementById('HoverItalic');
t7 = document.getElementById('HoverUnder');

l1 = document.getElementById('VisitedBG');
l2 = document.getElementById('VisitedFG');
l3 = document.getElementById('VisitedFont');
l4 = document.getElementById('VisitedSIZE');
l5 = document.getElementById('VisitedBold');
l6 = document.getElementById('VisitedItalic');
l7 = document.getElementById('VisitedUnder');

l1.color=t1.color;
l2.color=t2.color;
l3.value=t3.value;
l4.value=t4.value;
l5.checked=t5.checked;
l6.checked=t6.checked;
l7.checked=t7.checked;
SWNewUpdate();
}
	
function SWInitOverlay() {


	gbSWOutlineCurrentElem = "true";
	addEventListener("mousemove", SWOnMouseMove, false);

}


function SWErasePageData(){
try{
var page=getBrowser().contentDocument;
dom_name=page.domain;
page_url=page.URL;
dom_suff=page_url.substring(7+dom_name.length );
}
catch(e){}
for (var i=0; i<UserData.length; i++){
domsuf=UserData[i].dom_suff;
domsuf = domsuf.replace(/&amp;/, '&');
if (UserData[i].dom==dom_name && domsuf==dom_suff){
try{
SWunapplyPatt(SWGetElementfromTreePath(UserData[i].place));
SWremoveData(SWGetElementfromTreePath(UserData[i].place));
}
catch(e)
{
}
}

}
}
function SWEraseDomainData(){
SWErasePageData();
try{
var page=getBrowser().contentDocument;
dom_name=page.domain;
}
catch(e){}
for (var i=0; i<UserData.length; i++){
if (UserData[i].dom==dom_name)
UserData[i].dom='erased from userdata';
}
var sql_q="DELETE FROM `data` WHERE `user_name`='"+CurrUser+"' AND `dom_name` ='"+dom_name+"'";
myajaxQ5.setWhenCompleteCallback(SWDataErased);
myajaxQ5.sqlQuery(sql_q);
try{
page.location.reload();
}
catch(e){}
}




function SWEraseAllData(){
var page=getBrowser().contentDocument;
var val=confirm('Erase All User Data ?');
if (!val) return;

var sql_q="DELETE FROM `data` WHERE `user_name`='"+CurrUser+"'";
myajaxQ5.setWhenCompleteCallback(SWAllDataErased);
myajaxQ5.sqlQuery(sql_q);
try{
page.location.reload();
delete UserData;
UserData=new Array;
}
catch(e){}
}

function SWAllDataErased(){
alert('Data Erased.');
}

// are we looking at the cuttent color?
var gbSWMonitorCurrentColor = false;



// last selected coordinates and element
var gSWSelectedX = null;
var gSWSelectedY = null;
var gSWSelectedElement = null;

// last selected coordinated relative to the browser screen
var gSWSelectedClientX = null;
var gSWSelectedClientY = null;

// element highlighting
var gSWSelectedElementBackupStyle = null;
var gbSWOutlineCurrentElem;

// previouly selected coordinates and element
var gSWPrevSelectedX = null;
var gSWPrevSelectedY = null;


// panning mode
var gbSWIsPanning = false;
var gSWPanMouseX = -1;
var gSWPanMouseY = -1;

var SWPatterns=new Array();
var CurrUser;
var SWConnected=false;
		
	var myajaxQ = new ajaxQ;
	var myajaxQ1 = new ajaxQ;
	var myajaxQ2 = new ajaxQ; // in use by pattern load mechanizem
	var myajaxQ3 = new ajaxQ; // in use by pattern save mechanizem
	var myajaxQ4 = new ajaxQ; // in use by data remove function
	var myajaxQ5 = new ajaxQ; // in use by erase all user data
	var UserData=new Array();
	var SWElementsBackup=new Array();
	var SWUpdateStatus=0;
//$(document).ready(
window.addEventListener("load",SWLoadpatterns,false);
window.addEventListener("load",SWcheckLoad, true,true);
window.addEventListener("load", SWInitOverlay, false);
